// Generated by the gRPC C++ plugin.
// If you make any local change, they will be lost.
// source: database.proto
#ifndef GRPC_database_2eproto__INCLUDED
#define GRPC_database_2eproto__INCLUDED

#include "database.pb.h"

#include <grpcpp/impl/codegen/async_stream.h>
#include <grpcpp/impl/codegen/async_unary_call.h>
#include <grpcpp/impl/codegen/method_handler_impl.h>
#include <grpcpp/impl/codegen/proto_utils.h>
#include <grpcpp/impl/codegen/rpc_method.h>
#include <grpcpp/impl/codegen/service_type.h>
#include <grpcpp/impl/codegen/status.h>
#include <grpcpp/impl/codegen/stub_options.h>
#include <grpcpp/impl/codegen/sync_stream.h>

namespace grpc {
class CompletionQueue;
class Channel;
class ServerCompletionQueue;
class ServerContext;
}  // namespace grpc

namespace mascot {

class Directory final {
 public:
  static constexpr char const* service_full_name() {
    return "mascot.Directory";
  }
  class StubInterface {
   public:
    virtual ~StubInterface() {}
    virtual ::grpc::Status ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::mascot::DirectoryReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> AsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(AsyncExportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> PrepareAsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(PrepareAsyncExportDeviceRaw(context, request, cq));
    }
    virtual ::grpc::Status ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::mascot::DirectoryReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> AsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(AsyncExportDevicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>> PrepareAsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>>(PrepareAsyncExportDevicesRaw(context, request, cq));
    }
    virtual ::grpc::Status ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::mascot::DirectoryImportReply* response) = 0;
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>> AsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>>(AsyncImportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>> PrepareAsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>>(PrepareAsyncImportDeviceRaw(context, request, cq));
    }
  private:
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* AsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* PrepareAsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* AsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryReply>* PrepareAsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>* AsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) = 0;
    virtual ::grpc::ClientAsyncResponseReaderInterface< ::mascot::DirectoryImportReply>* PrepareAsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) = 0;
  };
  class Stub final : public StubInterface {
   public:
    Stub(const std::shared_ptr< ::grpc::ChannelInterface>& channel);
    ::grpc::Status ExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::mascot::DirectoryReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> AsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(AsyncExportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> PrepareAsyncExportDevice(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(PrepareAsyncExportDeviceRaw(context, request, cq));
    }
    ::grpc::Status ExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::mascot::DirectoryReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> AsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(AsyncExportDevicesRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>> PrepareAsyncExportDevices(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>>(PrepareAsyncExportDevicesRaw(context, request, cq));
    }
    ::grpc::Status ImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::mascot::DirectoryImportReply* response) override;
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>> AsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>>(AsyncImportDeviceRaw(context, request, cq));
    }
    std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>> PrepareAsyncImportDevice(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) {
      return std::unique_ptr< ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>>(PrepareAsyncImportDeviceRaw(context, request, cq));
    }

   private:
    std::shared_ptr< ::grpc::ChannelInterface> channel_;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* AsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* PrepareAsyncExportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfo& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* AsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryReply>* PrepareAsyncExportDevicesRaw(::grpc::ClientContext* context, const ::mascot::DbDevExportInfos& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>* AsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) override;
    ::grpc::ClientAsyncResponseReader< ::mascot::DirectoryImportReply>* PrepareAsyncImportDeviceRaw(::grpc::ClientContext* context, const ::mascot::DeviceName& request, ::grpc::CompletionQueue* cq) override;
    const ::grpc::internal::RpcMethod rpcmethod_ExportDevice_;
    const ::grpc::internal::RpcMethod rpcmethod_ExportDevices_;
    const ::grpc::internal::RpcMethod rpcmethod_ImportDevice_;
  };
  static std::unique_ptr<Stub> NewStub(const std::shared_ptr< ::grpc::ChannelInterface>& channel, const ::grpc::StubOptions& options = ::grpc::StubOptions());

  class Service : public ::grpc::Service {
   public:
    Service();
    virtual ~Service();
    virtual ::grpc::Status ExportDevice(::grpc::ServerContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response);
    virtual ::grpc::Status ExportDevices(::grpc::ServerContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response);
    virtual ::grpc::Status ImportDevice(::grpc::ServerContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response);
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ExportDevice() {
      ::grpc::Service::MarkMethodAsync(0);
    }
    ~WithAsyncMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevice(::grpc::ServerContext* context, ::mascot::DbDevExportInfo* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(0, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ExportDevices() {
      ::grpc::Service::MarkMethodAsync(1);
    }
    ~WithAsyncMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestExportDevices(::grpc::ServerContext* context, ::mascot::DbDevExportInfos* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(1, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  template <class BaseClass>
  class WithAsyncMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithAsyncMethod_ImportDevice() {
      ::grpc::Service::MarkMethodAsync(2);
    }
    ~WithAsyncMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    void RequestImportDevice(::grpc::ServerContext* context, ::mascot::DeviceName* request, ::grpc::ServerAsyncResponseWriter< ::mascot::DirectoryImportReply>* response, ::grpc::CompletionQueue* new_call_cq, ::grpc::ServerCompletionQueue* notification_cq, void *tag) {
      ::grpc::Service::RequestAsyncUnary(2, context, request, response, new_call_cq, notification_cq, tag);
    }
  };
  typedef WithAsyncMethod_ExportDevice<WithAsyncMethod_ExportDevices<WithAsyncMethod_ImportDevice<Service > > > AsyncService;
  template <class BaseClass>
  class WithGenericMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ExportDevice() {
      ::grpc::Service::MarkMethodGeneric(0);
    }
    ~WithGenericMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ExportDevices() {
      ::grpc::Service::MarkMethodGeneric(1);
    }
    ~WithGenericMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithGenericMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithGenericMethod_ImportDevice() {
      ::grpc::Service::MarkMethodGeneric(2);
    }
    ~WithGenericMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable synchronous version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ExportDevice() {
      ::grpc::Service::MarkMethodStreamed(0,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::DbDevExportInfo, ::mascot::DirectoryReply>(std::bind(&WithStreamedUnaryMethod_ExportDevice<BaseClass>::StreamedExportDevice, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ExportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportDevice(::grpc::ServerContext* context, const ::mascot::DbDevExportInfo* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportDevice(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DbDevExportInfo,::mascot::DirectoryReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ExportDevices : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ExportDevices() {
      ::grpc::Service::MarkMethodStreamed(1,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::DbDevExportInfos, ::mascot::DirectoryReply>(std::bind(&WithStreamedUnaryMethod_ExportDevices<BaseClass>::StreamedExportDevices, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ExportDevices() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ExportDevices(::grpc::ServerContext* context, const ::mascot::DbDevExportInfos* request, ::mascot::DirectoryReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedExportDevices(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DbDevExportInfos,::mascot::DirectoryReply>* server_unary_streamer) = 0;
  };
  template <class BaseClass>
  class WithStreamedUnaryMethod_ImportDevice : public BaseClass {
   private:
    void BaseClassMustBeDerivedFromService(const Service *service) {}
   public:
    WithStreamedUnaryMethod_ImportDevice() {
      ::grpc::Service::MarkMethodStreamed(2,
        new ::grpc::internal::StreamedUnaryHandler< ::mascot::DeviceName, ::mascot::DirectoryImportReply>(std::bind(&WithStreamedUnaryMethod_ImportDevice<BaseClass>::StreamedImportDevice, this, std::placeholders::_1, std::placeholders::_2)));
    }
    ~WithStreamedUnaryMethod_ImportDevice() override {
      BaseClassMustBeDerivedFromService(this);
    }
    // disable regular version of this method
    ::grpc::Status ImportDevice(::grpc::ServerContext* context, const ::mascot::DeviceName* request, ::mascot::DirectoryImportReply* response) final override {
      abort();
      return ::grpc::Status(::grpc::StatusCode::UNIMPLEMENTED, "");
    }
    // replace default version of method with streamed unary
    virtual ::grpc::Status StreamedImportDevice(::grpc::ServerContext* context, ::grpc::ServerUnaryStreamer< ::mascot::DeviceName,::mascot::DirectoryImportReply>* server_unary_streamer) = 0;
  };
  typedef WithStreamedUnaryMethod_ExportDevice<WithStreamedUnaryMethod_ExportDevices<WithStreamedUnaryMethod_ImportDevice<Service > > > StreamedUnaryService;
  typedef Service SplitStreamedService;
  typedef WithStreamedUnaryMethod_ExportDevice<WithStreamedUnaryMethod_ExportDevices<WithStreamedUnaryMethod_ImportDevice<Service > > > StreamedService;
};

}  // namespace mascot


#endif  // GRPC_database_2eproto__INCLUDED
